import {NgModule} from "@angular/core";
import {RouterModule} from "@angular/router";

@NgModule({
  imports: [RouterModule.forChild([
    {
      path: '',
      loadChildren: () => import('../general/general.module').then(m => m.GeneralModule),
      data: {hasAdminMenu: true},
      pathMatch: 'full'
    },
    {
      path: 'users',
      loadChildren: () => import('../users/users.module').then(m => m.UsersModule),
      data: {hasAdminMenu: true},
      pathMatch: 'full'
    },
    {
      path: 'indicators',
      loadChildren: () => import('../topic/topic.module').then(m => m.TopicModule),
      pathMatch: 'full'
    },
    {
      path: 'indicators/:topic',
      loadChildren: () => import('../topic/topic.module').then(m => m.TopicModule),
      pathMatch: 'full'
    },
    {
      path: 'admin-tools',
      loadChildren: () => import('../admin-tools/admin-tools-routing.module').then(m => m.AdminToolsRoutingModule),
      data: {
        hasAdminMenu: true,
        param: 'stakeholder'
      }
    }
  ])]
})
export class AdminStakeholderRoutingModule {

}
